#[doc = "Register `CFG20` reader"]
pub struct R(crate::R<CFG20_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CFG20_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CFG20_SPEC>> for R {
    fn from(reader: crate::R<CFG20_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CFG20` writer"]
pub struct W(crate::W<CFG20_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CFG20_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CFG20_SPEC>> for W {
    fn from(writer: crate::W<CFG20_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `STAT_MD` reader - Mode selection for each bit of the status register. A '0' is transparent mode, where internal routing is read indrectly by CPU firmware. A '1' is sticky-clear-on-read mode, where once the given bit is set, it will stay set until the CPU reads the bit."]
pub struct STAT_MD_R(crate::FieldReader<u8, u8>);
impl STAT_MD_R {
    pub(crate) fn new(bits: u8) -> Self {
        STAT_MD_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for STAT_MD_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `STAT_MD` writer - Mode selection for each bit of the status register. A '0' is transparent mode, where internal routing is read indrectly by CPU firmware. A '1' is sticky-clear-on-read mode, where once the given bit is set, it will stay set until the CPU reads the bit."]
pub struct STAT_MD_W<'a> {
    w: &'a mut W,
}
impl<'a> STAT_MD_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Mode selection for each bit of the status register. A '0' is transparent mode, where internal routing is read indrectly by CPU firmware. A '1' is sticky-clear-on-read mode, where once the given bit is set, it will stay set until the CPU reads the bit."]
    #[inline(always)]
    pub fn stat_md(&self) -> STAT_MD_R {
        STAT_MD_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Mode selection for each bit of the status register. A '0' is transparent mode, where internal routing is read indrectly by CPU firmware. A '1' is sticky-clear-on-read mode, where once the given bit is set, it will stay set until the CPU reads the bit."]
    #[inline(always)]
    pub fn stat_md(&mut self) -> STAT_MD_W {
        STAT_MD_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Status Register input mode selection\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cfg20](index.html) module"]
pub struct CFG20_SPEC;
impl crate::RegisterSpec for CFG20_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [cfg20::R](R) reader structure"]
impl crate::Readable for CFG20_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [cfg20::W](W) writer structure"]
impl crate::Writable for CFG20_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CFG20 to value 0"]
impl crate::Resettable for CFG20_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
